/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_ison.c,v 1.7.4.4 2002/03/09 11:10:36 lloydy Exp $
 *
 */
#include "chunkyircd.h"
#include "network.h"

CMIRCD_MODULE(1.02,CMD_CLIENT );

/* 
 * CMD_ISON, deals with ISON requests 
 */
int cmd_ison(ClientInfo c_ptr,ServerInfo s_ptr,Cmd cmd)
{
	int i;
	ClientInfo curr=NULL;
	char buffer[BUF_SIZE];
	unsigned int char_count;
	
	/* Don't accept from other servers */
	if(s_ptr) {
		 
		return 0;
	}
	
	/* Check we have at least one */
	if(!cmd->params[0]) {
		send_numeric(c_ptr,get_my_server(),461,"ISON :Not enough parameters");
		 
		return 0;
	}
	
	/* Do it */
	ircd_sprintf(buffer,BUF_SIZE,"%s",":");
	char_count = BUF_SIZE - strlen(buffer);
	for(i=0;cmd->params[i];i++) {
		curr=NULL;
		curr=client_locate(cmd->params[i]);
		if(curr) {
			strncat(buffer,curr->nick,char_count);
			char_count -= strlen(curr->nick);
			strncat(buffer," ",char_count);
			char_count--;
		}
	}
	
	send_numeric(c_ptr,get_my_server(),303,buffer);
	
	 
	return 1;
}

