/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_links.c,v 1.8.4.4 2002/03/09 11:10:36 lloydy Exp $
 *
 */
#include "chunkyircd.h"
#include "network.h"
#include "server.h"

CMIRCD_MODULE(1.02,CMD_CLIENT | CMD_SERVER );

static int forward_links(ClientInfo,char *,char *);

/*
 * Reply to or forward a LINKS request
 */
int cmd_links(ClientInfo c_ptr,ServerInfo s_ptr,Cmd cmd)
{
	ClientInfo origin=NULL;

	if(s_ptr) {
		origin=client_locate(cmd->origin);
		if(!origin) {
			/* Can't use a nonexistant client */
			return 0;
		}
	} else {
		origin=c_ptr;
	}
	
	/* Check its for us if there is a dest */
	if(cmd->params[0]) {
		/* Check here */
		/* cmd->params[1] is the dest */
		if(cmd->params[1] && lc_strncmp(cmd->params[1],get_my_server()->name,-1) ) {
			return forward_links(origin,cmd->params[0],cmd->params[1]);
		}
		
	}
	
	/* Actually list */	
	server_links(origin,cmd->params[0]?cmd->params[0]:"*");

	/* Send End val */
	send_numeric(origin,get_my_server(),365,":End of LINKS list");
	
	/* Clean Up */
	 
	return 1;
}

static int forward_links(ClientInfo origin,char *mask,char *dest_name)
{
	ServerInfo dest=NULL;
	char buffer[BUF_SIZE];

	dest=server_locate(dest_name);

	if(!dest) {
		ircd_sprintf(buffer,BUF_SIZE,"%s :No such server",dest_name);
		send_numeric(origin,get_my_server(),402,buffer);
	} else {
		ircd_sprintf(buffer,BUF_SIZE,"LINKS %s %s",mask,dest_name);
		send_origin_server(dest,origin->nick,buffer);
	}
	return 1;
}
	
