/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_lusers.c,v 1.8.4.4 2002/03/09 11:10:36 lloydy Exp $
 *
 */
#include "chunkyircd.h"
#include "network.h"
#include "server.h"

CMIRCD_MODULE(1.02,CMD_CLIENT | CMD_SERVER );

/*
 * Return a count of the users on this server
 * or forward it to another server
 */
int cmd_lusers(ClientInfo c_ptr,ServerInfo s_ptr,Cmd cmd)
{
	ClientInfo source=NULL;
	ServerInfo dest=NULL;
	char buffer[BUF_SIZE];
	
	
	if(!c_ptr || s_ptr) 
		return 0;
	
	/* Check the target */
	if(cmd->params[1]) {
		dest=server_locate(cmd->params[1]);
		if(dest) {
			source=c_ptr?c_ptr:client_locate(cmd->origin);

			if(dest==get_my_server()) {
				/* Its for us */
				send_lusers(source,cmd->params[0]?cmd->params[0]:"*");
			} else {
				ircd_sprintf(buffer,BUF_SIZE,"LUSERS %s %s",cmd->params[0]?cmd->params[0]:"",
									    dest->name);
				send_origin_server(dest,source->nick,buffer);
			}
			
		} else {
			/* Return ERR_NOSUCHSERVER */
			ircd_sprintf(buffer,BUF_SIZE,"%s :No Such Server",cmd->params[1]);
			send_numeric(c_ptr,get_my_server(),402,buffer);
		}
	} else {
		/* Return it from us */
		send_lusers(c_ptr,cmd->params[0]?cmd->params[0]:"*");
	}
	

	/* Clean up */	
	 
	return 1;
}

