/* This file is part of Chunky Monkey IRCD 
 *
 * Chunky Monkey IRCD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Chunky Monkey IRCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Chunky Monkey IRCD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $Id: cmd_part.c,v 1.9.4.3 2002/03/09 11:10:37 lloydy Exp $
 *
 */
#include "modules.h"

CMIRCD_MODULE(1.02,CMD_CLIENT | CMD_SERVER );

int cmd_part(ClientInfo c_ptr,ServerInfo s_ptr,Cmd cmd)
{
	ChannelInfo chan=NULL;
	int i;
	ChannelMember curr_client=NULL;
	ClientInfo client=NULL;
	char buffer[BUF_SIZE];
	
	if(c_ptr) {
		client=c_ptr;
	} else {
		client=client_locate(cmd->origin);
		if(!client) {
			 
			return 0;
		}
	}
	
	if(cmd->params[0]!=NULL) {
		for(i=0;cmd->params[i]!=NULL;i++) {
			chan=locate_channel(cmd->params[i]);
			if(c_ptr) {
				/* Check channel exists */
				chan=locate_channel(cmd->params[i]);
				if(chan==NULL) {
					/* Inform user channel doesn't exist */
					ircd_sprintf(buffer,BUF_SIZE,"%s :No such channel",cmd->params[i]);
					send_numeric(client,get_my_server(),403,buffer);
					 
					return 0;
				}
				
				/* Check we are a member of this channel */
				curr_client=NULL;
				curr_client=channel_is_client_on(client,chan);
				if(curr_client==NULL){
					/* in here, client isn't on that channel */
					ircd_sprintf(buffer,BUF_SIZE,"%s :You're not on that channel",chan->name);
					send_numeric(client,get_my_server(),442,buffer);
					 
					return 0;
				}
			} else {
				if(!chan)  {
					 
					return 0;
				}
			}
			ircd_sprintf(buffer,BUF_SIZE,"PART %s :%s",cmd->params[i],cmd->text?cmd->text:"");
			
			if(client->fd!=-1) 
				send_client_client(client,client,buffer);
			
			/* Send to room */
			send_to_local_channel(client,chan,buffer);
			
			/* Announce it */
			servers_relay(s_ptr,client->nick,buffer);
			
			/* Remove client from channel list */
			if(!channel_rem_client(client,chan)) 
				log_msg(LOG_DEBUG1,"Failed to remove client(%s) from channel(%s), %s,%d",
						     client->nick,chan->name,__FILE__,__LINE__);
						
			
			/* Remove channel from client list */
			if(!client_rem_chan(client,chan))
				log_msg(LOG_DEBUG1,"Failed to remove channel(%s) from client(%s), %s,%d",
						     chan->name,client->nick,__FILE__,__LINE__);

			/* Do we need to close the channel */
			channel_needclose(chan);

		}	
		 
		return 1;			
	} else {
		/* Should inform client about not enough parameters */
		sprintf(buffer,"PART :Not enough paramters");
		send_numeric(client,get_my_server(),461,buffer);
		 
		return 0;
	}
}
